function [accuracy, Predict_test_Label,SpecificitySensitivity,weightall,SelectFeatureIndex,Specif_Sensit_acc_fold,MaxDim]=KNNMVPA(Cfg)

Fold=Cfg.Fold;
strSelectFeature=Cfg.FeatureSelectionStr;
Data=Cfg.Data;
SelectFeatureNum=Cfg.SelectFeatureNum;
% if ~strcmp(strSelectFeature,'None')
%     weightall=zeros(SelectFeatureNum(length(SelectFeatureNum)),length(SelectFeatureNum),max(Fold));
% else
%     weightall=zeros(size(Data,2),max(Fold));
% end

Label=Cfg.Label;
NumNeighbor=Cfg.NumNeighbor;
FishZStr=Cfg.FishZStr;
nDim=Cfg.ContrPCA;
strFeatureReduce=Cfg.FeatureReduceStr;
ReLabel=[];
train_data=[];
%%
%20200113 edit 
if ~strcmp(strFeatureReduce,'PCA (Principal Component Analysis)')
    if ~strcmp(strSelectFeature,'None') && ~strcmp(strSelectFeature,'Lasso')
        %Feature selection
        weightall=zeros(size(Data,2),length(SelectFeatureNum),max(Fold));
        SelectFeatureIndex=zeros(size(Data,2),max(Fold));
    else
        %Feature selection
        weightall=zeros(size(Data,2),max(Fold));
        SelectFeatureIndex=[];
    end
else
    weightall=[];
    SelectFeatureIndex=[];
end
if ~strcmp(strFeatureReduce,'PCA (Principal Component Analysis)')
    MaxDim='NODimensionalityReduction';
else
    for i=1:max(Fold)    
        train_data=Data;
        train_data(find(Fold==i),:)=[];    
        if strcmp(FishZStr,'Cloumn Normalization')
            train_data=zscore(train_data);
        end
        if strcmp(strFeatureReduce,'PCA (Principal Component Analysis)')
           [coeff,DataScore,latent,tsquared,explained] = pca(train_data);
            RContributionLatent=num2cell([explained, cumsum(explained)]);
            RContributionLatent=cell2mat(RContributionLatent);
            MaxDimPCA(i)=min(find(RContributionLatent(:,2)>nDim));
        end
    end
    MaxDim=max(MaxDimPCA);
end
ReLabel=unique(Label);
h=waitbar(0,'Runing...');
for i=1:max(Fold)    
    str=['Runing...',num2str(i/max(Fold)*100),'%'];
    waitbar(i/max(Fold),h,str);
    IX=[];
    test_data=Data(find(Fold==i),:);
    test_label=Label(find(Fold==i));
    train_label=Label;
    train_data=Data;
    train_label(find(Fold==i),:)=[];
    train_data(find(Fold==i),:)=[];
    
    if strcmp(FishZStr,'Cloumn Normalization')
        meantrain_data=mean(train_data);
        stdtrain_data=std(train_data);
        train_data=zscore(train_data);
        for izscore=1:size(train_data,2)
            test_data(:,izscore)=(test_data(:,izscore)-meantrain_data(izscore))./stdtrain_data(izscore);
        end
    end
    if strcmp(strFeatureReduce,'PCA (Principal Component Analysis)')
        [coeff,DataScore,latent,tsquared,explained] = pca(train_data);
        test_data1=bsxfun(@minus,test_data,mean(train_data,1))*coeff;
        train_data=DataScore(:,1:MaxDim);
        test_data=test_data1(:,1:MaxDim);
    end
    %%
    switch strSelectFeature
        case 'None'%
            Factor = ClassificationKNN.fit(train_data, train_label, 'NumNeighbors', NumNeighbor);
            [predict_label, dec_values] = predict(Factor, test_data);
            Specif_Sensit_acc_fold(i,1)=length(find(predict_label(find(predict_label==test_label))==ReLabel(1)))/length(find(test_label==ReLabel(1)))*100;
            Specif_Sensit_acc_fold(i,2)=length(find(predict_label(find(predict_label==test_label))==ReLabel(2)))/length(find(test_label==ReLabel(2)))*100;
            Specif_Sensit_acc_fold(i,3)=length(find(predict_label==test_label))/length(test_label)*100;
            
            acc= length(find(predict_label== test_label))/length(test_label)*100;
            accuracy(i)=acc;
            
            PredictLabel(find(Fold==i),1)=predict_label;
            RealLabel(find(Fold==i),1)=test_label;
            DecValues(find(Fold==i),1)=dec_values(:,1);
        case 'Lasso'
            %%
            %20200113 edit
            [B,FitInfo]=lasso(train_data,train_label,'CV',10);
            IndexMinMSE=FitInfo.IndexMinMSE;
            train_data=train_data(:,find(B(:,IndexMinMSE)~=0));
            test_data=test_data(:,find(B(:,IndexMinMSE)~=0));
            model = ClassificationKNN.fit(train_data, train_label, 'NumNeighbors', NumNeighbor);
            [predict_label, dec_values] = predict(model, test_data);
            
            acc= length(find(predict_label== test_label))/length(test_label)*100;
            accuracy(i)=acc;
            
            Specif_Sensit_acc_fold(i,1)=length(find(predict_label(find(predict_label==test_label))==ReLabel(1)))/length(find(test_label==ReLabel(1)))*100;
            Specif_Sensit_acc_fold(i,2)=length(find(predict_label(find(predict_label==test_label))==ReLabel(2)))/length(find(test_label==ReLabel(2)))*100;
            Specif_Sensit_acc_fold(i,3)=length(find(predict_label==test_label))/length(test_label)*100;
            
            PredictLabel(find(Fold==i),1)=predict_label;
            RealLabel(find(Fold==i),1)=test_label;
            DecValues(find(Fold==i),1)=dec_values(:,1);
        case 'F-Score'
            [IX,ind] = fget(train_label,train_data);
            SelectFeatureIndex(:,i)=IX;
            for j=1:length(SelectFeatureNum)
                kWeight=SelectFeatureNum(j);
                test_datarank=test_data(:,IX(1:kWeight));
                Factor = ClassificationKNN.fit(train_data(:,IX(1:kWeight)), train_label, 'NumNeighbors', NumNeighbor);
                [predict_label, dec_values] = predict(Factor, test_datarank(:,1:kWeight));
                Specif_Sensit_acc_fold(i,1,j)=length(find(predict_label(find(predict_label==test_label))==ReLabel(1)))/length(find(test_label==ReLabel(1)))*100;
                Specif_Sensit_acc_fold(i,2,j)=length(find(predict_label(find(predict_label==test_label))==ReLabel(2)))/length(find(test_label==ReLabel(2)))*100;
                Specif_Sensit_acc_fold(i,3,j)=length(find(predict_label==test_label))/length(test_label)*100;
                acc= length(find(predict_label== test_label))/length(test_label)*100;
                accuracy(i,j)=acc;
                
                PredictLabel(find(Fold==i),j)=predict_label;
                RealLabel(find(Fold==i),j)=test_label;
                DecValues(find(Fold==i),j)=dec_values(:,1);
            end
    end
end
close(h)
%%
if strcmp(strSelectFeature,'None')
    SpecificitySensitivity(1)=length(find(RealLabel(find(RealLabel==ReLabel(1)))==PredictLabel(find(RealLabel==ReLabel(1)))))/length(find(RealLabel==ReLabel(1)))*100;
    SpecificitySensitivity(2)=length(find(RealLabel(find(RealLabel==ReLabel(2)))==PredictLabel(find(RealLabel==ReLabel(2)))))/length(find(RealLabel==ReLabel(2)))*100;
    Predict_test_Label=[RealLabel PredictLabel DecValues];
else
    for j=1:size(RealLabel,2) %j means feature
        SpecificitySensitivity(1,j)=length(find(RealLabel(find(RealLabel(:,j)==ReLabel(1)),j)==PredictLabel(find(RealLabel(:,j)==ReLabel(1)),j)))/length(find(RealLabel(:,j)==ReLabel(1)))*100;
        SpecificitySensitivity(2,j)=length(find(RealLabel(find(RealLabel(:,j)==ReLabel(2)),j)==PredictLabel(find(RealLabel(:,j)==ReLabel(2)),j)))/length(find(RealLabel(:,j)==ReLabel(2)))*100;
        Predict_test_Label(:,:,j)=[RealLabel(:,j) PredictLabel(:,j) DecValues(:,j)];
    end
end
